import json
import urllib3
import boto3


http = urllib3.PoolManager()

def lambda_handler(event, context):
    
    print("Bitcoin Price Tracker!")
    
    response = http.request('GET', 'https://api.coindesk.com/v1/bpi/currentprice.json')
    data = json.loads(response.data)
    price = str(data["bpi"]["USD"]["rate_float"])
    print("Bitcoin price is " + price)
    
    print("This shows that the lambda_handler is triggered by EventBridge")
    
    event_text = json.dumps(event, indent=2)
    print(f"Received event: {event_text}")

    sns = boto3.client("sns")
    try:
        response = sns.publish(
        TargetArn="arn:aws:sns:us-east-2:295566809004:mailtrap_new_users",
        Message=json.dumps({
            "Message" : price,
        }),
        Subject='Current Bitcoin price is ' + price,
        )['MessageId']
    
    except Exception:
        print("Error not published!")
        raise 
    
    else:
        return response
